package io.controller;


import io.common.constant.Constant;
import io.common.page.PageData;
import io.common.utils.Result;
import io.common.validator.AssertUtils;
import io.common.validator.ValidatorUtils;
import io.common.validator.group.AddGroup;
import io.common.validator.group.DefaultGroup;
import io.common.validator.group.UpdateGroup;
import io.modules.item.dto.CaseDTO;
import io.modules.item.dto.OrderDTO;
import io.modules.item.service.CaseService;
import io.modules.item.service.OrderService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.annotation.Order;
import org.springframework.web.bind.annotation.*;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Parameters;
import jakarta.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;


/**
 * 病例表
 *
 * @author Mark #
 * @since 1.0.0 2025-05-13
 */
@RestController
@RequestMapping("/api/case")
@Tag(name="病例表")
@CrossOrigin
public class CaseController {
    @Autowired
    private CaseService caseService;

    @Autowired
    private OrderService orderService;

    @GetMapping("page")
    @Operation(summary = "分页")
    @Parameters({
        @Parameter(name = Constant.PAGE, description = "当前页码，从1开始", in = ParameterIn.QUERY, required = true, ref="int") ,
        @Parameter(name = Constant.LIMIT, description = "每页显示记录数", in = ParameterIn.QUERY,required = true, ref="int") ,
        @Parameter(name = Constant.ORDER_FIELD, description = "排序字段", in = ParameterIn.QUERY, ref="String") ,
        @Parameter(name = Constant.ORDER, description = "排序方式，可选值(asc、desc)", in = ParameterIn.QUERY, ref="String")
    })

    public Result<PageData<CaseDTO>> page(@Parameter(hidden = true) @RequestParam Map<String, Object> params){
        PageData<CaseDTO> page = caseService.page(params);

        return new Result<PageData<CaseDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @Operation(summary = "信息")

    public Result<CaseDTO> get(@PathVariable("id") Long id){
        CaseDTO data = caseService.get(id);
        return new Result<CaseDTO>().ok(data);
    }

    @PostMapping
    @Operation(summary = "保存")
    public Result save(@RequestBody CaseDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);
        caseService.save(dto);
        OrderDTO orderDTO = orderService.get(dto.getOrderId());
        orderDTO.setOrderStatus(1);
        orderService.update(orderDTO);
        return new Result();
    }

    @PutMapping
    @Operation(summary = "修改")

    public Result update(@RequestBody CaseDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);

        caseService.update(dto);

        return new Result();
    }


}
